Subject: Re: [PATCH RFC net-next 0/4] bridge: improve cache utilization

From: Stephen Hemminger <[email-masked]>
Date: Tue, 31 Jan 2017 10:21:37 -0800

On Tue, 31 Jan 2017 19:09:09 +0100
Nikolay Aleksandrov <[email-masked]> wrote:

> On 31/01/17 17:41, Nikolay Aleksandrov wrote:
> >>
> >> I agree with the first 3 patches, but not the last one.
> >> Changing the API just for a performance hack is not necessary. Instead make
> >> the algorithm smarter and use per-cpu values.
> >>  
> > 
> > Thanks for the feedback, I would very much prefer any of the other two approaches
> > I tried (per-cpu pool and per-cpu for each fdb), from the two the second one -
> > per-cpu for each fdb is much simpler, so would it be acceptable to do per-cpu allocation
> > for each fdb ?
> > 
> > 
> >   
> 
> Okay, after some more testing the version with per-cpu per-fdb allocations, at 300 000 fdb entries
> I got 120 failed per-cpu allocs which seems okay. I'll wait a little more and will repost the series
> with per-cpu allocations and without the RFC tag.
> 
> Thanks,
>  Nik
> 

You could also use a mark/sweep algorithm (rather than recording updated).
It turns out that clearing is fast (can be unlocked).
The timer workqueue can mark all fdb entries (during scan), then in forward
function clear the bit if it is set. This would turn writes into reads.

To keep the API for last used, just change the resolution to be scan interval.